package handler

import (
	"github.com/gin-gonic/gin"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
)

func WrapDeleteSubAccountHandler(ctx *gin.Context) {
	handler := newdeleteSubAccountHandler(ctx)
	baseRun(handler)
}

func newdeleteSubAccountHandler(ctx *gin.Context) *DeleteSubAccountHandler {
	return &DeleteSubAccountHandler{
		req:  http_model.NewDeleteSubAccountRequest(),
		resp: http_model.NewDeleteSubAccountResponse(),
		ctx:  ctx,
	}
}

type DeleteSubAccountHandler struct {
	req  *http_model.DeleteSubAccountRequest
	resp *http_model.CommonResponse
	ctx  *gin.Context
}

func (h *DeleteSubAccountHandler) getRequest() interface{} {
	return h.req
}
func (h *DeleteSubAccountHandler) getContext() *gin.Context {
	return h.ctx
}
func (h *DeleteSubAccountHandler) getResponse() interface{} {
	return h.resp
}
func (h *DeleteSubAccountHandler) run() {
	subAccountData := http_model.DeleteSubAccountRequest{}
	subAccountData = *h.req
	err := service.SubAccount.DeleteSubAccount(h.ctx, subAccountData)
	if err != nil {
		// fmt.Println(err)
		h.resp.Status = 40000
		h.resp.Message = err.Error()
		return
	}
	h.resp.Status = 20000
	h.resp.Message = "ok"
	return
}

func (h *DeleteSubAccountHandler) checkParam() error {
	return nil
}
